
package de.ivu.elect.business.benutzerverwaltung.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort;

@RequestScoped
@Named(BenutzerEinsatzortConversationSelect.COMPONENT_NAME)
public class BenutzerEinsatzortConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "benutzerEinsatzortConversationSelect";

  @Inject
  protected transient BenutzerEinsatzortExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(BenutzerEinsatzortConversationStore.class)
  protected transient BenutzerEinsatzortConversationStore conversationStore;

  public BenutzerEinsatzortConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public BenutzerEinsatzort getEntity() {
    return getEntityInternal();
  }

  private BenutzerEinsatzort getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(BenutzerEinsatzort entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzortPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(BenutzerEinsatzort entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzortPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzortPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected BenutzerEinsatzort attach(BenutzerEinsatzort entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected BenutzerEinsatzort attach( de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzortPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
